#include 'activeX.ch'
#include 'dll.ch'

#define xlMaximized        -4137

*************************
PROCEDURE AppSys ; RETURN
PROCEDURE DbeSys ; RETURN
**************************

**************
PROCEDURE Main
**************
LOCAL oExcel, oWorksheet, oCells, oRange1, oRange2, oCellRange, nCont, cFirstAddress

oExcel:= CreateObject( 'Excel.Application' )

IF oExcel = nil ; QUIT ; ENDIF

oExcel:visible      := .T.
oExcel:displayAlerts:= .F.
oExcel:windowState  := xlMaximized
SetForegroundWindow( oExcel:hwnd )

oExcel:workbooks:add()

oWorksheet:= oExcel:worksheets( 1 )
oWorksheet:activate()

oWorksheet:name:= 'Hoja de prueba'

oCells:= oWorksheet:cells

FOR nCont:= 1 TO 5
    oCells:columns( nCont ):columnWidth:= 22

    oCells:item( 1, nCont ):value:= 'Items'
    oCells:item( 2, nCont ):value:= 'Item 1'
    oCells:item( 3, nCont ):value:= 'Item 2'
    oCells:item( 4, nCont ):value:= 'Item 3'
    oCells:item( 5, nCont ):value:= 'Item 4'
    oCells:item( 6, nCont ):value:= 'Item 5'
    oCells:item( 7, nCont ):value:= 'Item 6'
    oCells:item( 8, nCont ):value:= 'Item 7'
NEXT

oRange1:= oWorksheet:range( 'B2', 'D5' )   // rango de las columnas 2, 3 y 4, iniciando en la fila 2 y hasta la fila 5
oRange2:= oWorksheet:range( 'B6', 'D8' )   // rango de las columnas 2, 3 y 4, iniciando en la fila 6 y hasta la fila 8

IF ( oCellRange:= oRange1:find( 'Item 2' ) ) # nil
   oCellRange:value:= 'Reemplazado rango 1'
   cFirstAddress   := oCellRange:address

   DO WHILE ( oCellRange:= oRange1:findNext( oCellRange ) ) # nil .AND. oCellRange:address # cFirstAddress
      oCellRange:value:= 'Reemplazado 1'
   ENDDO
ENDIF
IF ( oCellRange:= oRange1:find( 'Item 8' ) ) # nil  // Lgicamente no va a tener efecto porque en el rango 1 no exite el Item 8 
   oCellRange:value:= 'Reemplazado rango 1'
ENDIF

IF ( oCellRange:= oRange2:find( 'Item 6' ) ) # nil
   oCellRange:value:= 'Reemplazado rango 2'
   cFirstAddress   := oCellRange:address

   DO WHILE ( oCellRange:= oRange2:findNext( oCellRange ) ) # nil .AND. oCellRange:address # cFirstAddress
      oCellRange:value:= 'Reemplazado 2'
   ENDDO
ENDIF
IF ( oCellRange:= oRange2:find( 'Item 3' ) ) # nil  // Lgicamente no va a tener efecto porque en el rango 2 no exite el Item 3
   oCellRange:value:= 'Reemplazado rango 2'
ENDIF

oExcel:destroy()
RETURN

DLLFUNCTION SetForegroundWindow( nHwnd ) USING STDCALL FROM USER32.DLL
